<template>
  <div class="hostList">
    <div>
      <!--  -->
      <div style="display: flex">
        <div></div>
        <el-input
          v-model="queryFormData.coinMin"
          placeholder="最小金币"
          size="large"
          style="width: 160px"
          type="number"
        />

        <el-input
          v-model="queryFormData.coinMax"
          placeholder="最大金币"
          size="large"
          style="width: 160px; margin-left: 50px"
          type="number"
        />

        <el-input
          v-model="queryFormData.levelMin"
          placeholder="最小等级"
          size="large"
          style="width: 160px; margin-left: 50px"
          type="number"
        />

        <el-input
          v-model="queryFormData.levelMax"
          placeholder="最大等级"
          size="large"
          style="width: 160px; margin-left: 50px"
          type="number"
        />

        <div style="width: 250px; margin-left: 50px; height: 50px; line-height: 50px">
          当前网络：{{ countryData }}
        </div>
        <div style="width: 160px; margin-left: 50px; height: 50px; line-height: 50px">
          总数：{{ getBrotherInfodata.total }}
        </div>
        <div style="width: 160px; margin-left: 50px; height: 50px; line-height: 50px">
          有效数：{{ getBrotherInfodata.valid }}
        </div>

        <el-button
          class="serch-button"
          style="margin-left: 50px"
          type="primary"
          @click="Resetss"
          >重置</el-button
        >

        <el-button
          class="serch-button"
          style="margin-left: 50px; width: 150px"
          type="primary"
          @click="openTikTok"
          >打开 TikTok 登录</el-button
        >
        <el-button
          v-show="queryFormData.isRunning"
          class="serch-button"
          style="margin-left: 50px"
          type="primary"
          @click="getBigBrother"
          >开始</el-button
        >
        <el-button
          v-show="!queryFormData.isRunning"
          class="serch-button"
          style="margin-left: 50px"
          type="primary"
          @click="BigBrotherstop"
          >结束</el-button
        >
      </div>
      <!-- `````````````````````````````````````````````````````````````````````````````````````````````````` -->
      <div style="width: 100%; border-bottom: 1px solid #e9e9e9; margin-top: 30px"></div>
      <!-- ···································································································· -->
      <div style="display: flex; margin-top: 30px; flex-wrap: wrap">
        <el-select
          v-model="searchForm.region"
          filterable
          placeholder="选择国家"
          size="large"
          style="width: 160px"
        >
          <el-option
            v-for="item in options"
            :key="item.value"
            :label="item.label"
            :value="item.value"
          />
        </el-select>

        <el-input
          v-model="searchForm.displayId"
          placeholder="大哥id"
          size="large"
          style="width: 160px; margin-left: 50px"
          clearable
        />

        <el-button
          class="serch-button"
          style="margin-left: 50px"
          type="primary"
          @click="serch"
          >查询</el-button
        >

        <el-button class="serch-button" type="primary" @click="reset"> 重置 </el-button>

        <el-button
          class="put-button"
          :disabled="tableData.length == 0"
          type="primary"
          @click="exportList"
          >导出Excel数据</el-button
        >
        <el-button
          @click="filterdialogVisible = true"
          style="width: 50px"
          class="put-button"
          type="primary"
          ><img style="height: 30px" src="@/assets/filter.png"
        /></el-button>
        <!-- <el-button @click="filterdialogVisible = true" style="width: 50px;" class="put-button" type="primary"><img
            style="height: 30px;" src="@/assets/filter.png"></el-button> -->
      </div>
      <!-- ····················································································································· -->
      <div class="hostTable center-justify">
        <el-table
          ref="multipleTableRef"
          :data="tableData"
          stripe
          v-loading="loading"
          max-height="500"
          @selection-change="handleSelectionChange"
        >
          <!-- <el-table-column type="selection" width="35" /> -->

          <el-table-column fixed prop="displayId" label="Id" width="170">
            <template #default="scope">
              <div class="hostIdText" @click="openHTML(scope.row.displayId)">
                {{ scope.row.displayId }}
              </div>
            </template>
          </el-table-column>

          <el-table-column
            v-for="label in labelList"
            :key="label.paramCode"
            :prop="label.paramCode"
            :label="label.paramCodeMeaning"
            width="170"
          >
            <template v-if="label.paramCode != 'createDt'" #default="scope"> </template>
          </el-table-column>
        </el-table>
      </div>
      <!-- ······································································································································ -->
      <!-- 分页 -->
      <div class="center-justify" style="margin-top: 30px">
        <el-pagination
          v-model:current-page="page"
          v-model:page-size="pageSize"
          background
          layout="sizes, prev, pager, next"
          :total="total"
          :page-sizes="[10, 20, 50, 100, 500, 1000]"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
        />
      </div>

      <!-- ·······································································弹窗······································································· -->
      <el-dialog v-model="filterdialogVisible" width="800px" :before-close="handleClose">
        <el-row :gutter="20">
          <el-col :span="4">
            <!-- <label>选择筛选条件</label> -->
            <div style="height: 100%; padding-top: 10px" class="center-justify">时间</div>
          </el-col>
          <el-col :span="10">
            <div><label>开始时间/结束时间</label></div>

            <el-date-picker
              v-model="createTimes"
              type="datetimerange"
              value-format="YYYY-MM-DD HH:mm:ss"
              placeholder="选择查询时间"
              size="large"
              style="width: 600px; margin-top: 10px"
            />
          </el-col>
        </el-row>

        <el-row
          v-for="(field, index) in fields"
          :key="index"
          :gutter="20"
          style="margin-bottom: 10px"
        >
          <el-col :span="4">
            <div style="height: 100%" class="center-justify">
              {{ field.label }}
            </div>
          </el-col>
          <el-col :span="10">
            <div><label>最小值</label></div>
            <el-input
              type="number"
              :oninput="'if(value.length>9)value=value.slice(0,9)'"
              v-model.number="searchForm[field.minModel]"
              placeholder="请输入最小值"
            />
          </el-col>
          <el-col :span="10">
            <div><label>最大值</label></div>
            <el-input
              type="number"
              :oninput="'if(value.length>9)value=value.slice(0,9)'"
              v-model.number="searchForm[field.maxModel]"
              placeholder="请输入最大值"
            />
          </el-col>
        </el-row>

        <el-row :gutter="20">
          <el-col :span="4">
            <!-- <label>选择筛选条件</label> -->
            <div style="height: 100%; padding-top: 10px" class="center-justify">排序</div>
          </el-col>
          <el-col :span="10">
            <div><label>排序类型</label></div>

            <el-select
              v-model="sortData.sortName"
              filterable
              placeholder="请选择"
              style="width: 240px"
            >
              <el-option
                v-for="item in sortNameOptions"
                :key="item.type"
                :label="item.label"
                :value="item.type"
              />
            </el-select>
          </el-col>
          <el-col :span="10">
            <div><label>升序/降序</label></div>

            <el-select
              v-model="sortData.sort"
              filterable
              placeholder="请选择"
              style="width: 240px"
            >
              <el-option
                v-for="item in [
                  { label: '升序', value: 'asc' },
                  { label: '降序', value: 'desc' },
                ]"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              />
            </el-select>
          </el-col>
        </el-row>

        <template #footer>
          <span class="dialog-footer">
            <el-button type="primary" @click="reset"> 重置 </el-button>
            <!-- <el-button @click="filterdialogVisible = false">取消</el-button> -->
            <el-button type="primary" @click="handelClick"> 确认 </el-button>
          </span>
        </template>
      </el-dialog>
    </div>
  </div>
</template>

<script setup>
// import { getToken, setToken, removeToken } from '@/utils/storage'
import {
  tkhostdata,
  dicts,
  tkhostdetail,
  downList,
  getStaffList,
  managerhosts,
  upholdinfo,
  getCountryinfo,
  accountName,
} from "@/api/account";
import { usePythonBridge } from "@/utils/pythonBridge";
import { getUser, setSerch, getSerch } from "@/utils/storage";
import { ref, reactive, onMounted } from "vue";
import EChartsComponent from "@/components/EChartsComponent.vue";
import { ElMessage, ElMessageBox } from "element-plus";
import { color } from "echarts";
import { getCountryName } from "@/utils/countryUtil";

//ip国家
let countryData = ref("");
//获取国家
const getIpInfo = async () => {
  try {
    const response = await fetch("https://ipapi.co/json/");
    if (!response.ok) {
      throw new Error("请求失败");
    }
    const data = await response.json();
    console.log("IP信息:", data.country);

    countryData.value = getCountryName(data.country);
  } catch (error) {
    console.error("请求出错:", error);
    ElMessageBox.prompt("请输入将要获取国家的中文名", "获取国家失败", {
      confirmButtonText: "确认",
      cancelButtonText: "取消",
      showClose: false,
      closeOnClickModal: false,
      showCancelButton: false,
    }).then(({ value }) => {
      countryData.value = value;
    });
    // .catch(() => {
    //     ElMessage({
    //         type: 'info',
    //         message: 'Input canceled',
    //     })
    // })
  }
};
//打开TikTok登录
function openTikTok() {
  loginTikTok();
}
//重置
function Resetss() {
  queryFormData.value = {};
}
//大哥climb
const queryFormData = ref({
  coinMin: "",
  coinMax: "",
  levelMin: "",
  levelMax: "",
  isRunning: true,
});
//时间
const timerId = ref(null);
const getBrotherInfodata = ref({
  total: 0,
  valid: 0,
});

function BigBrotherstop() {
  queryFormData.value.tenantId = userInfo.value.tenantId;
  queryFormData.value.region = countryData.value;
  controlTask(JSON.stringify(queryFormData.value)).then((res) => {
    queryFormData.value.isRunning = true;
    clearInterval(timerId.value);
    timerId.value = null;
  });
}
function getBigBrother() {
  queryFormData.value.tenantId = userInfo.value.tenantId;
  queryFormData.value.region = countryData.value;
  controlTask(JSON.stringify(queryFormData.value)).then((res) => {
    queryFormData.value.isRunning = false;
    timerId.value = setInterval(() => {
      getBrotherInfo().then((res) => {
        getBrotherInfodata.value = res;
      });
    }, 1000);
  });
}

const loading = ref(false);
//py方法
const {
  givePyAnchorId,
  exportToExcel,
  loginTikTok,
  controlTask,
  getBrotherInfo,
} = usePythonBridge();

let num = ref(0);
//账号信息
const userInfo = ref({});
//主播列表DOM
const multipleTableRef = ref(null);
let labelList = ref([
  { paramCode: "userIdStr", paramCodeMeaning: "用户id" },
  { paramCode: "level", paramCodeMeaning: "等级" },
  { paramCode: "hostcoins", paramCodeMeaning: "打赏的金币" },
  { paramCode: "totalGiftCoins", paramCodeMeaning: "打赏金币总和" },
  { paramCode: "hostDisplayId", paramCodeMeaning: "所在直播间主播id" },
  { paramCode: "region", paramCodeMeaning: "地区" },
  { paramCode: "followerCount", paramCodeMeaning: "粉丝数" },
  { paramCode: "followingCount", paramCodeMeaning: "关注数" },
  { paramCode: "createTime", paramCodeMeaning: "创建时间" },
]);

const tableData = ref([]);
//主播列表传参
const searchForm = ref({});
const createTimes = ref([]);
//分页
const page = ref(1);
const pageSize = ref(10);
const fields = [
  { label: "打赏的金币", minModel: "hostcoinsMin", maxModel: "hostcoinsMax" },
  { label: "打赏金币总和", minModel: "totalGiftCoinsMin", maxModel: "totalGiftCoinsMax" },
  { label: "等级", minModel: "levelMin", maxModel: "levelMax" },
];
//排序
let sortData = ref({ sortName: "createTime", sort: "desc" });

//排序类型
let sortNameOptions = ref([
  { label: "创建时间", type: "createTime" },
  { label: "打赏的金币", type: "hostsCoins" },
  { label: "打赏金币总和", type: "totalGiftCoins" },
  { label: "等级", type: "level" },
]);
//员工选择列表
let staffOptions = ref([]);
//筛选条件选择列表

//选择的员工
let staffValue = ref("");
//选择的主播列表
let selectHostList = ref([]);
//分配弹窗是否弹出
let dialogFormVisible = ref(false);
//分配情况弹窗是否弹出
let hostNameVisible = ref(false);

//备注弹窗是否弹出
let commentVisible = ref(false);
//筛选弹窗是否弹出
let filterdialogVisible = ref(false);
//分配的员工
let staffId = ref({});
//备注信息
let commentInfo = ref("");
//备注信息主播
let commentHost = ref("");
//分页
let total = ref(0);
//是否渲染
const isPopoverVisible = reactive({});

let options = ref([]);

let version = ref("0.0.0");

onMounted(() => {
  setTimeout(() => {
    getUserdata();
  }, 500);
});

async function getUserdata() {
  const User = await getUser();
  userInfo.value = User;
  getCountry(); //获取国家
  getlist(); //获取主播列表
  getIpInfo();
}

function serch() {
  page.value = 1;
  getlist();
}

function exportList() {
  // if (searchForm.value.dataType == "InvitationType") {
  //   searchForm.value.dataEnd = searchForm.value.dataStart;
  // }
  exportToExcel(requestParams.value);

  // //浏览器导出方法
  // downList('export/hostsinfo',
  //   {
  //     searchTime: searchForm.value.time,
  //     region: searchForm.value.country,
  //     pageSize: pageSize.value,
  //     page: page.value,
  //     userId: userInfo.value.userId,
  //   }
  // );
}
//分页每页条数
function handleSizeChange(val) {
  console.log(`${val} items per page`);
  getlist();
}
//分页页数
function handleCurrentChange(val) {
  console.log(`current page: ${val}`);
  getlist();
}
//选择行
function handleSelectionChange(data) {
  console.log(data);
  selectHostList.value = [];
  data.forEach((item) => {
    selectHostList.value.push(item.hostId);
  });
  // multipleTableRef.value = data
  // console.log(multipleTableRef.value)
}
//时间格式化
function formatDate(date) {
  const year = date.getFullYear();
  const month = String(date.getMonth() + 1).padStart(2, "0"); // 月份从 0开始，需要+1
  const day = String(date.getDate()).padStart(2, "0");
  const hours = String(date.getHours()).padStart(2, "0");
  const minutes = String(date.getMinutes()).padStart(2, "0");
  const seconds = String(date.getSeconds()).padStart(2, "0");

  return `${year}-${month}-${day} ${hours}:${minutes}:${seconds}`;
}
//获取主播列表
//记录请求参数
let requestParams = ref({});
const getlist = () => {
  loading.value = true;
  tkhostdata({
    tenantId: Number(userInfo.value.tenantId),
    sort: sortData.value.sort, //正序倒序
    sortName: sortData.value.sortName, //排序类型
    current: page.value,
    pageSize: pageSize.value,
    createTimeStart: createTimes.value[0],
    createTimeEnd: createTimes.value[1],
    ...searchForm.value, //筛选条件
  }).then((res) => {
    loading.value = false;
    console.log(res);
    if (res) {
      requestParams.value = res.records;
      console.log(res.records);
      total.value = Number(res.total);
      tableData.value = res.records.map((item) => ({
        level: item.level, // 等级
        createTime: formatDate(new Date(item.createTime)), // 创建时间
        followerCount: item.followerCount, //  粉丝数
        followingCount: item.followingCount, //  关注数
        hostDisplayId: item.hostDisplayId, //  所在直播间主播id
        hostcoins: item.hostcoins, //  打赏的金币
        region: item.region, //  地区
        totalGiftCoins: item.totalGiftCoins, //  打赏金币总和
        userIdStr: item.userIdStr, //  用户id
        displayId: item.displayId,
      }));
    }
  });
};
function handelClick() {
  filterdialogVisible.value = false;
}
function reset() {
  searchForm.value = {};
  sortData.value = { sortName: "createTime", sort: "desc" };
  createTimes.value = [];
}
function handleClose(done) {
  console.log("关闭");
  done();
}

//修改主播维护状态
// function handleSelectChange(event, data) {

//   upholdinfo({
//     "hostId": data.hostId,
//     "userId": userInfo.value.userId,
//     "tenantId": userInfo.value.tenantId,
//     // "comment": "我已经尽力维护，但是失败了",
//     "useable": event.target.value
//   }).then(res => {
//     console.log(res)
//   })
// }

//更改主播维护备注

// function uphostcomment() {
//   upholdinfo({
//     "hostId": commentHost.value,
//     "userId": userInfo.value.userId,
//     "tenantId": userInfo.value.tenantId,
//     "comment": commentInfo.value,
//   }).then(res => {
//     console.log(res)
//     serch()
//     commentVisible.value = false
//   })
// }

function filterTag(value, row) {
  console.log(row.useable, value);
  return row.useable === value;
}

//获取国家
function getCountry() {
  getCountryinfo({})
    .then((res) => {
      console.log("````````国家`````````", res);
      res.forEach((item) => {
        if (item.countryGroupName) {
          options.value.push({
            value: item.countryGroupName,
            label: item.countryGroupName,
          });
        }
      });
      console.log("````````国家2`````````", options.value);
    })
    .catch((err) => {
      console.log("getCountry", err);
    });
}

//获取下级员工
// const getStaff = () => {
//   getStaffList({
//     userId: userInfo.value.userId,
//     activeYn: userInfo.value.activeYn,
//     tenantId: userInfo.value.tenantId,
//   }).then(res => {
//     console.log(res)
//     res.forEach(item => {
//       staffOptions.value.push({
//         value: item.userId,
//         label: item.userName
//       })
//     })
//   })
// }

// //分配主播给员工
// function allocation() {
//   managerhosts({
//     "manaId": userInfo.value.userId,
//     "userId": staffValue.value,
//     "tenantId": userInfo.value.tenantId,
//     "hostIds": selectHostList.value
//   }).then(res => {
//     if (res) {
//       dialogFormVisible.value = false

//     }
//   })
// }

//获取主播信息
// const getTkhostdetail = (id) => {
//   tkhostdetail({
//     hostId: id,
//     // page: 1,
//     searchTimeStart: '20250401',
//     searchTimeEnd: '20250403'
//   }).then(res => {

//     console.log(labelList.value)

//   })

// }

function openPopover(hostId, paramCode) {
  isPopoverVisible[`${hostId}-${paramCode}`] = true;
}

function closePopover(hostId, paramCode) {
  // isPopoverVisible[`${hostId}-${paramCode}`] = false;
}

function openHTML(id) {
  console.log(id);

  givePyAnchorId(id);

  // upholdinfo({
  //   "hostId": id,
  //   "userId": userInfo.value.userId,
  //   "tenantId": userInfo.value.tenantId,
  //   // "comment": "我已经尽力维护，但是失败了",
  //   "useable": "Y"
  // }).then(res => {

  // getlist();
  // })
}

// function openAccountName(idStr) {
//   if (idStr) {
//     hostNameVisible.value = true
//     accountName(idStr).then(res => {
//       staffId.value = JSON.stringify(res).replace(/[{}"]/g, '') // 移除所有 {} 和 "
//         .split(',')            // 按逗号分割成数组

//       console.log(res)
//     })
//   }
// }
</script>

<style lang="less">
.hostList {
  box-sizing: border-box;
  // height: 100vh;
  padding: 40px;

  /* 页面无法选中 */
  // -webkit-user-select: none;
  // -moz-user-select: none;
  // -ms-user-select: none;
  // user-select: none;

  .hostTable {
    width: 100%;
    padding: 30px 0;

    .hostIdText {
      text-decoration: underline;
      cursor: pointer;
    }
  }

  .serch-button {
    width: 80px;
    height: 47px;
    background: @btn-bg-color;
    border-radius: 10px;
    border: none;
  }

  .put-button {
    width: 132px;
    height: 47px;
    background: @btn-bg-color;
    border-radius: 10px;
    border: none;
  }
}

.el-dialog {
  --el-dialog-font-line-height: 50px;
  --el-dialog-width: 600px;
  --el-dialog-border-radius: 8px;

  // border: 10px solid @bg-color-light;
}

.center-line {
  display: flex;
  flex-direction: column;
  align-items: center;
  // justify-content: center;
}

.center-justify {
  display: flex;
  justify-content: space-around;
  align-items: center;
}

.center-align {
  display: flex;
  justify-content: space-between;
}

.center-flex {
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>

<style scoped lang="less">
::v-deep(.el-input__wrapper) {
  background-color: #f2faf9;
  border: 1px solid @bg-color;
  height: 44px;
}

::v-deep(.el-select__wrapper) {
  background-color: #f2faf9;
  border: 1px solid @bg-color;
  height: 48px;
}

::v-deep(.el-pagination.is-background .el-pager li.is-active) {
  background-color: @bg-color;
}
</style>
